pcl::RIFTEstimation< PointInT, GradientT, PointOutT > Class Template Reference
Module features

RIFTEstimation estimates the Rotation Invariant Feature Transform descriptors for a given point cloud dataset containing points and intensity. More...

`#include <pcl/features/rift.h>`

Inheritance diagram for pcl::RIFTEstimation< PointInT, GradientT, PointOutT >:

## Public Types

typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef Feature< PointInT, PointOutT >::PointCloudOut | PointCloudOut
typedef pcl::PointCloud< GradientT > | PointCloudGradient
typedef PointCloudGradient::Ptr | PointCloudGradientPtr
typedef PointCloudGradient::ConstPtr | PointCloudGradientConstPtr
typedef boost::shared_ptr< RIFTEstimation< PointInT, GradientT, PointOutT > > | Ptr
typedef boost::shared_ptr< const RIFTEstimation< PointInT, GradientT, PointOutT > > | ConstPtr
Public Types inherited from pcl::Feature< PointInT, PointOutT >
typedef PCLBase< PointInT > | BaseClass
typedef boost::shared_ptr< Feature< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Feature< PointInT, PointOutT > > | ConstPtr
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(size_t, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, size_t index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| RIFTEstimation ()
| Empty constructor. More...
void | setInputGradient (const PointCloudGradientConstPtr &gradient)
| Provide a pointer to the input gradient data. More...
PointCloudGradientConstPtr | getInputGradient () const
| Returns a shared pointer to the input gradient data. More...
void | setNrDistanceBins (int nr_distance_bins)
| Set the number of bins to use in the distance dimension of the RIFT descriptor. More...
int | getNrDistanceBins () const
| Returns the number of bins in the distance dimension of the RIFT descriptor. More...
void | setNrGradientBins (int nr_gradient_bins)
| Set the number of bins to use in the gradient orientation dimension of the RIFT descriptor. More...
int | getNrGradientBins () const
| Returns the number of bins in the gradient orientation dimension of the RIFT descriptor. More...
void | computeRIFT (const PointCloudIn &cloud, const PointCloudGradient &gradient, int p_idx, float radius, const std::vector< int > &indices, const std::vector< float > &squared_distances, Eigen::MatrixXf &rift_descriptor)
| Estimate the Rotation Invariant Feature Transform (RIFT) descriptor for a given point based on its spatial neighborhood of 3D points and the corresponding intensity gradient vector field. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | computeFeature (PointCloudOut &output)
| Estimate the Rotation Invariant Feature Transform (RIFT) descriptors at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface (), the gradient in setInputGradient (), and the spatial locator in setSearchMethod () More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

PointCloudGradientConstPtr | gradient_
| The intensity gradient of the input point cloud data. More...
int | nr_distance_bins_
| The number of distance bins in the descriptor. More...
int | nr_gradient_bins_
| The number of gradient orientation bins in the descriptor. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename GradientT, typename PointOutT>
class pcl::RIFTEstimation< PointInT, GradientT, PointOutT >

RIFTEstimation estimates the Rotation Invariant Feature Transform descriptors for a given point cloud dataset containing points and intensity.

For more information about the RIFT descriptor, see:

Svetlana Lazebnik, Cordelia Schmid, and Jean Ponce. A sparse texture representation using local affine regions. In IEEE Transactions on Pattern Analysis and Machine Intelligence, volume 27, pages 1265-1278, August 2005.

Author
  Michael Dixon

Definition at line 60 of file rift.h.

## Member Typedef Documentation

template<typename PointInT , typename GradientT , typename PointOutT >

typedef boost::shared_ptr<const RIFTEstimation<PointInT, GradientT, PointOutT> > pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::ConstPtr

Definition at line 80 of file rift.h.

template<typename PointInT , typename GradientT , typename PointOutT >

typedef pcl::PointCloud<GradientT> pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::PointCloudGradient

Definition at line 75 of file rift.h.

template<typename PointInT , typename GradientT , typename PointOutT >

typedef PointCloudGradient::ConstPtr pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::PointCloudGradientConstPtr

Definition at line 77 of file rift.h.

template<typename PointInT , typename GradientT , typename PointOutT >

typedef PointCloudGradient::Ptr pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::PointCloudGradientPtr

Definition at line 76 of file rift.h.

template<typename PointInT , typename GradientT , typename PointOutT >

typedef pcl::PointCloud<PointInT> pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::PointCloudIn

Definition at line 72 of file rift.h.

template<typename PointInT , typename GradientT , typename PointOutT >

typedef Feature<PointInT, PointOutT>::PointCloudOut pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::PointCloudOut

Definition at line 73 of file rift.h.

template<typename PointInT , typename GradientT , typename PointOutT >

typedef boost::shared_ptr<RIFTEstimation<PointInT, GradientT, PointOutT> > pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::Ptr

Definition at line 79 of file rift.h.

## Constructor & Destructor Documentation

template<typename PointInT , typename GradientT , typename PointOutT >

pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::RIFTEstimation | ( |  | ) |

inline

Empty constructor.

Definition at line 84 of file rift.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_.

## Member Function Documentation

template<typename PointInT , typename GradientT , typename PointOutT >

void pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

protected virtual

Estimate the Rotation Invariant Feature Transform (RIFT) descriptors at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface (), the gradient in setInputGradient (), and the spatial locator in setSearchMethod ()

Parameters

  [out] | output | the resultant point cloud model dataset that contains the RIFT feature estimates

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 113 of file rift.hpp.

References pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

Referenced by pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::getNrGradientBins().

template<typename PointInT , typename GradientT , typename PointOutT >

void pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::computeRIFT | ( | const PointCloudIn & | cloud,
|  | const PointCloudGradient & | gradient,
|  | int | p_idx,
|  | float | radius,
|  | const std::vector< int > & | indices,
|  | const std::vector< float > & | squared_distances,
|  | Eigen::MatrixXf & | rift_descriptor
| ) |  |

Estimate the Rotation Invariant Feature Transform (RIFT) descriptor for a given point based on its spatial neighborhood of 3D points and the corresponding intensity gradient vector field.

Parameters

  [in] | cloud | the dataset containing the Cartesian coordinates of the points
  [in] | gradient | the dataset containing the intensity gradient at each point in cloud
  [in] | p_idx | the index of the query point in cloud (i.e. the center of the neighborhood)
  [in] | radius | the radius of the RIFT feature
  [in] | indices | the indices of the points that comprise p_idx's neighborhood in cloud
  [in] | squared_distances | the squared distances from the query point to each point in the neighborhood
  [out] | rift_descriptor | the resultant RIFT descriptor

Definition at line 48 of file rift.hpp.

References pcl::PointCloud< PointT >::points.

Referenced by pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::getNrGradientBins().

template<typename PointInT , typename GradientT , typename PointOutT >

PointCloudGradientConstPtr pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::getInputGradient | ( |  | ) | const

inline

Returns a shared pointer to the input gradient data.

Definition at line 97 of file rift.h.

References pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::gradient_.

template<typename PointInT , typename GradientT , typename PointOutT >

int pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::getNrDistanceBins | ( |  | ) | const

inline

Returns the number of bins in the distance dimension of the RIFT descriptor.

Definition at line 107 of file rift.h.

References pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::nr_distance_bins_.

template<typename PointInT , typename GradientT , typename PointOutT >

int pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::getNrGradientBins | ( |  | ) | const

inline

Returns the number of bins in the gradient orientation dimension of the RIFT descriptor.

Definition at line 117 of file rift.h.

References pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::computeFeature(), pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::computeRIFT(), and pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::nr_gradient_bins_.

template<typename PointInT , typename GradientT , typename PointOutT >

void pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::setInputGradient | ( | const PointCloudGradientConstPtr & | gradient | ) |

inline

Provide a pointer to the input gradient data.

Parameters

  [in] | gradient | a pointer to the input gradient data

Definition at line 93 of file rift.h.

References pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::gradient_.

template<typename PointInT , typename GradientT , typename PointOutT >

void pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::setNrDistanceBins | ( | int | nr_distance_bins | ) |

inline

Set the number of bins to use in the distance dimension of the RIFT descriptor.

Parameters

  [in] | nr_distance_bins | the number of bins to use in the distance dimension of the RIFT descriptor

Definition at line 103 of file rift.h.

References pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::nr_distance_bins_.

template<typename PointInT , typename GradientT , typename PointOutT >

void pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::setNrGradientBins | ( | int | nr_gradient_bins | ) |

inline

Set the number of bins to use in the gradient orientation dimension of the RIFT descriptor.

Parameters

  [in] | nr_gradient_bins | the number of bins to use in the gradient orientation dimension of the RIFT descriptor

Definition at line 113 of file rift.h.

References pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::nr_gradient_bins_.

## Member Data Documentation

template<typename PointInT , typename GradientT , typename PointOutT >

PointCloudGradientConstPtr pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::gradient_

protected

The intensity gradient of the input point cloud data.

Definition at line 145 of file rift.h.

Referenced by pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::getInputGradient(), and pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::setInputGradient().

template<typename PointInT , typename GradientT , typename PointOutT >

int pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::nr_distance_bins_

protected

The number of distance bins in the descriptor.

Definition at line 148 of file rift.h.

Referenced by pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::getNrDistanceBins(), and pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::setNrDistanceBins().

template<typename PointInT , typename GradientT , typename PointOutT >

int pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::nr_gradient_bins_

protected

The number of gradient orientation bins in the descriptor.

Definition at line 151 of file rift.h.

Referenced by pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::getNrGradientBins(), and pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::setNrGradientBins().

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/rift.h
- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/impl/rift.hpp